package com.hc.business.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.hc.business.mapper.CourseTypeRelationMapper;
import com.hc.business.model.CourseTypeRelation;
import com.hc.business.service.CourseTypeRelationService;
import org.springframework.stereotype.Service;

/**
 * (CourseTypeRelation)表服务实现类
 *
 * @author java
 * @since 2021-02-02 09:25:11
 */

@Service("courseTypeRelationService")
public class CourseTypeRelationServiceImpl implements CourseTypeRelationService {

    private final CourseTypeRelationMapper courseTypeRelationMapper;

    public CourseTypeRelationServiceImpl(CourseTypeRelationMapper courseTypeRelationMapper) {
        this.courseTypeRelationMapper = courseTypeRelationMapper;
    }

    /**
     * 通过ID查询单条数据
     *
     * @param courseTypeReId 主键
     * @return 实例对象
     */
    @Override
    public CourseTypeRelation queryById(Integer courseTypeReId) {
        return this.courseTypeRelationMapper.selectByPrimaryKey(courseTypeReId);
    }

    /**
     * 新增数据
     *
     * @param courseTypeRelation 实例对象
     * @return 实例对象
     */
    @Override
    public CourseTypeRelation insert(CourseTypeRelation courseTypeRelation) {
        courseTypeRelation.setCreateTime(System.currentTimeMillis());
        this.courseTypeRelationMapper.insert(courseTypeRelation);
        return courseTypeRelation;
    }

    /**
     * 修改数据
     *
     * @param courseTypeRelation 实例对象
     * @return 实例对象
     */
    @Override
    public CourseTypeRelation update(CourseTypeRelation courseTypeRelation) {
        this.courseTypeRelationMapper.updateByPrimaryKeySelective(courseTypeRelation);
        return this.queryById(courseTypeRelation.getCourseTypeReId());
    }

    /**
     * 通过主键删除数据
     *
     * @param courseTypeReId 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Integer courseTypeReId) {
        return this.courseTypeRelationMapper.deleteByPrimaryKey(courseTypeReId) > 0;
    }

    /**
     * 分页查询多条数据
     *
     * @param page 页码
     * @param size 查询条数
     * @return 对象列表
     */
    @Override
    public PageInfo queryAllByLimit(int page, int size) {
        return PageHelper.startPage(page, size).doSelectPageInfo(this.courseTypeRelationMapper::selectAll);
    }
}